import {Component, computed, effect, inject, input, InputSignal, OnInit, Signal, WritableSignal} from '@angular/core';
import {FormBuilder, FormGroup, ReactiveFormsModule, Validators} from "@angular/forms";
import {GetTask} from "../dto/models";
import {TodoService} from "../service/todo.service";
import {DatePipe} from "@angular/common";

@Component({
  selector: 'app-edit',
  imports: [
    ReactiveFormsModule
  ],
  templateUrl: './edit.component.html',
  standalone: true,
  styleUrl: './edit.component.css'
})
export default class EditComponent implements OnInit{
  private fb: FormBuilder = inject(FormBuilder);
  private todoService: TodoService = inject(TodoService);
  public form!: FormGroup;
  public todo: InputSignal<GetTask|null> = input<GetTask|null>(null);
  public kys = effect(() => {
    console.log(this.todo())
  });

  constructor() {
    effect(() => {
      this.form = this.fb.group({
        title: [this.todo()?.title, Validators.required],
        dueDate: [new DatePipe('en-US').transform(this.todo()?.dueDate, 'yyyy-MM-dd'), Validators.required],
      })
    });
  }

  ngOnInit() {
  }

  edit() {
    const edited = {
      ...this.todo(),
      ...this.form.value,
    }

    this.todoService.edit(edited, this.todo()?.id ?? 0).subscribe(() => this.todoService.todos.reload())
  }
}
