import {Component, inject, signal, WritableSignal} from '@angular/core';
import {TodoService} from "../service/todo.service";
import {DatePipe} from "@angular/common";
import {GetTask} from "../dto/models";
import EditComponent from "../edit/edit.component";

@Component({
  selector: 'app-table',
  standalone: true,
  imports: [
    DatePipe,
    EditComponent,
  ],
  templateUrl: './table.component.html',
  styleUrl: './table.component.css'
})
export class TableComponent {
  todoService: TodoService = inject(TodoService);
  todos = this.todoService.todos;
  editingTodo: WritableSignal<GetTask|null> = signal(null);

  toggleDone(todo: GetTask) {
    this.todoService.toggleDone(todo).subscribe(() => this.todos.reload());
  }

  delete(id: number) {
    this.todoService.delete(id).subscribe(() => this.todos.reload());
  }

  edit(todo: GetTask) {
    this.editingTodo.set(todo);
  }
}
